<?php
namespace Grav\Plugin\ShoppingCart;

/**
 * Class ShoppingCart
 * @package Grav\Plugin
 */
class ShoppingCart
{
    /**
     * Get the available countries
     *
     * @return array
     */
    public static function getCountries()
    {
        return [
            'AF'  => 'Afghanistan',
            'AL'  => 'Albania',
            'DZ'  => 'Algeria',
            'AS'  => 'American Samoa',
            'AD'  => 'Andorra',
            'AO'  => 'Angola',
            'AI'  => 'Anguilla',
            'AQ'  => 'Antarctica',
            'AG'  => 'Antigua and Barbuda',
            'AR'  => 'Argentina',
            'AM'  => 'Armenia',
            'AW'  => 'Aruba',
            'AU'  => 'Australia',
            'AT'  => 'Austria',
            'AZ'  => 'Azerbaijan',
            'BH'  => 'Bahrain',
            'BD'  => 'Bangladesh',
            'BB'  => 'Barbados',
            'BY'  => 'Belarus',
            'BE'  => 'Belgium',
            'BZ'  => 'Belize',
            'BJ'  => 'Benin',
            'BM'  => 'Bermuda',
            'BT'  => 'Bhutan',
            'BO'  => 'Bolivia',
            'BA'  => 'Bosnia and Herzegovina',
            'BW'  => 'Botswana',
            'BV'  => 'Bouvet Island',
            'BR'  => 'Brazil',
            'IO'  => 'British Indian Ocean Territory',
            'VG'  => 'British Virgin Islands',
            'BN'  => 'Brunei',
            'BG'  => 'Bulgaria',
            'BF'  => 'Burkina Faso',
            'BI'  => 'Burundi',
            'CI'  => 'Côte d\'Ivoire',
            'KH'  => 'Cambodia',
            'CM'  => 'Cameroon',
            'CA'  => 'Canada',
            'CV'  => 'Cape Verde',
            'KY'  => 'Cayman Islands',
            'CF'  => 'Central African Republic',
            'TD'  => 'Chad',
            'CL'  => 'Chile',
            'CN'  => 'China',
            'CX'  => 'Christmas Island',
            'CC'  => 'Cocos (Keeling) Islands',
            'CO'  => 'Colombia',
            'KM'  => 'Comoros',
            'CG'  => 'Congo',
            'CK'  => 'Cook Islands',
            'CR'  => 'Costa Rica',
            'HR'  => 'Croatia',
            'CU'  => 'Cuba',
            'CY'  => 'Cyprus',
            'CZ'  => 'Czech Republic',
            'CD'  => 'Democratic Republic of the Congo',
            'DK'  => 'Denmark',
            'DJ'  => 'Djibouti',
            'DM'  => 'Dominica',
            'DO'  => 'Dominican Republic',
            'TP'  => 'East Timor',
            'EC'  => 'Ecuador',
            'EG'  => 'Egypt',
            'SV'  => 'El Salvador',
            'GQ'  => 'Equatorial Guinea',
            'ER'  => 'Eritrea',
            'EE'  => 'Estonia',
            'ET'  => 'Ethiopia',
            'FO'  => 'Faeroe Islands',
            'FK'  => 'Falkland Islands',
            'FJ'  => 'Fiji',
            'FI'  => 'Finland',
            'MK'  => 'Former Yugoslav Republic of Macedonia',
            'FR'  => 'France',
            'FX'  => 'France, Metropolitan',
            'GF'  => 'French Guiana',
            'PF'  => 'French Polynesia',
            'TF'  => 'French Southern Territories',
            'GA'  => 'Gabon',
            'GE'  => 'Georgia',
            'DE'  => 'Germany',
            'GH'  => 'Ghana',
            'GI'  => 'Gibraltar',
            'GR'  => 'Greece',
            'GL'  => 'Greenland',
            'GD'  => 'Grenada',
            'GP'  => 'Guadeloupe',
            'GU'  => 'Guam',
            'GT'  => 'Guatemala',
            'GN'  => 'Guinea',
            'GW'  => 'Guinea-Bissau',
            'GY'  => 'Guyana',
            'HT'  => 'Haiti',
            'HM'  => 'Heard and Mc Donald Islands',
            'HN'  => 'Honduras',
            'HK'  => 'Hong Kong',
            'HU'  => 'Hungary',
            'IS'  => 'Iceland',
            'IN'  => 'India',
            'ID'  => 'Indonesia',
            'IR'  => 'Iran',
            'IQ'  => 'Iraq',
            'IE'  => 'Ireland',
            'IL'  => 'Israel',
            'IT'  => 'Italy',
            'JM'  => 'Jamaica',
            'JP'  => 'Japan',
            'JO'  => 'Jordan',
            'KZ'  => 'Kazakhstan',
            'KE'  => 'Kenya',
            'KI'  => 'Kiribati',
            'KW'  => 'Kuwait',
            'KG'  => 'Kyrgyzstan',
            'LA'  => 'Laos',
            'LV'  => 'Latvia',
            'LB'  => 'Lebanon',
            'LS'  => 'Lesotho',
            'LR'  => 'Liberia',
            'LY'  => 'Libya',
            'LI'  => 'Liechtenstein',
            'LT'  => 'Lithuania',
            'LU'  => 'Luxembourg',
            'MO'  => 'Macau',
            'MG'  => 'Madagascar',
            'MW'  => 'Malawi',
            'MY'  => 'Malaysia',
            'MV'  => 'Maldives',
            'ML'  => 'Mali',
            'MLT' => 'Malta',
            'MT'  => 'Mayotte',
            'MH'  => 'Marshall Islands',
            'MQ'  => 'Martinique',
            'MR'  => 'Mauritania',
            'MU'  => 'Mauritius',
            'MX'  => 'Mexico',
            'FM'  => 'Micronesia',
            'MD'  => 'Moldova',
            'MC'  => 'Monaco',
            'MN'  => 'Mongolia',
            'ME'  => 'Montenegro',
            'MS'  => 'Montserrat',
            'MA'  => 'Morocco',
            'MZ'  => 'Mozambique',
            'MM'  => 'Myanmar',
            'NA'  => 'Namibia',
            'NR'  => 'Nauru',
            'NP'  => 'Nepal',
            'NL'  => 'Netherlands',
            'AN'  => 'Netherlands Antilles',
            'NC'  => 'New Caledonia',
            'NZ'  => 'New Zealand',
            'NI'  => 'Nicaragua',
            'NE'  => 'Niger',
            'NG'  => 'Nigeria',
            'NU'  => 'Niue',
            'NF'  => 'Norfolk Island',
            'KP'  => 'North Korea',
            'MP'  => 'Northern Marianas',
            'NO'  => 'Norway',
            'OM'  => 'Oman',
            'PK'  => 'Pakistan',
            'PW'  => 'Palau',
            'PA'  => 'Panama',
            'PG'  => 'Papua New Guinea',
            'PY'  => 'Paraguay',
            'PE'  => 'Peru',
            'PH'  => 'Philippines',
            'PN'  => 'Pitcairn Islands',
            'PL'  => 'Poland',
            'PT'  => 'Portugal',
            'PR'  => 'Puerto Rico',
            'QA'  => 'Qatar',
            'RE'  => 'Reunion',
            'RO'  => 'Romania',
            'RU'  => 'Russia',
            'RW'  => 'Rwanda',
            'ST'  => 'São Tomé and Príncipe',
            'SH'  => 'Saint Helena',
            'PM'  => 'St. Pierre and Miquelon',
            'KN'  => 'Saint Kitts and Nevis',
            'LC'  => 'Saint Lucia',
            'VC'  => 'Saint Vincent and the Grenadines',
            'WS'  => 'Samoa',
            'SM'  => 'San Marino',
            'SA'  => 'Saudi Arabia',
            'SN'  => 'Senegal',
            'RS'  => 'Serbia',
            'SC'  => 'Seychelles',
            'SL'  => 'Sierra Leone',
            'SG'  => 'Singapore',
            'SK'  => 'Slovakia',
            'SI'  => 'Slovenia',
            'SB'  => 'Solomon Islands',
            'SO'  => 'Somalia',
            'ZA'  => 'South Africa',
            'GS'  => 'South Georgia and the South Sandwich Islands',
            'KR'  => 'South Korea',
            'ES'  => 'Spain',
            'LK'  => 'Sri Lanka',
            'SD'  => 'Sudan',
            'SR'  => 'Suriname',
            'SJ'  => 'Svalbard and Jan Mayen Islands',
            'SZ'  => 'Swaziland',
            'SE'  => 'Sweden',
            'CH'  => 'Switzerland',
            'SY'  => 'Syria',
            'TW'  => 'Taiwan',
            'TJ'  => 'Tajikistan',
            'TZ'  => 'Tanzania',
            'TH'  => 'Thailand',
            'BS'  => 'The Bahamas',
            'GM'  => 'The Gambia',
            'TG'  => 'Togo',
            'TK'  => 'Tokelau',
            'T0'  => 'Tonga',
            'TT'  => 'Trinidad and Tobago',
            'TN'  => 'Tunisia',
            'TR'  => 'Turkey',
            'TM'  => 'Turkmenistan',
            'TC'  => 'Turks and Caicos Islands',
            'TV'  => 'Tuvalu',
            'VI'  => 'US Virgin Islands',
            'UG'  => 'Uganda',
            'UA'  => 'Ukraine',
            'AE'  => 'United Arab Emirates',
            'GB'  => 'United Kingdom',
            'US'  => 'United States',
            'UM'  => 'United States Minor Outlying Islands',
            'UY'  => 'Uruguay',
            'UZ'  => 'Uzbekistan',
            'VU'  => 'Vanuatu',
            'VA'  => 'Vatican City',
            'VE'  => 'Venezuela',
            'VN'  => 'Vietnam',
            'WF'  => 'Wallis and Futuna Islands',
            'EH'  => 'Western Sahara',
            'YE'  => 'Yemen',
            'ZM'  => 'Zambia',
            'ZW'  => 'Zimbabwe',
        ];
    }

    /**
     * Get the available currencies codes
     *
     * @return array
     */
    public static function getCurrencies()
    {
        return [
            "AED" => "AED",
            "AFN" => "AFN",
            "ALL" => "ALL",
            "AMD" => "AMD",
            "ANG" => "ANG",
            "AOA" => "AOA",
            "ARS" => "ARS",
            "AUD" => "AUD",
            "AWG" => "AWG",
            "AZN" => "AZN",
            "BAM" => "BAM",
            "BBD" => "BBD",
            "BDT" => "BDT",
            "BGN" => "BGN",
            "BHD" => "BHD",
            "BIF" => "BIF",
            "BMD" => "BMD",
            "BOB" => "BOB",
            "BRL" => "BRL",
            "BSD" => "BSD",
            "BTN" => "BTN",
            "BWP" => "BWP",
            "BYR" => "BYR",
            "BZD" => "BZD",
            "CAD" => "CAD",
            "CDF" => "CDF",
            "CHF" => "CHF",
            "CLP" => "CLP",
            "CNY" => "CNY",
            "COP" => "COP",
            "CRC" => "CRC",
            "CUC" => "CUC",
            "CVE" => "CVE",
            "CZK" => "CZK",
            "DJF" => "DJF",
            "DKK" => "DKK",
            "DOP" => "DOP",
            "DZD" => "DZD",
            "EEK" => "EEK",
            "EGP" => "EGP",
            "ERN" => "ERN",
            "ETB" => "ETB",
            "EUR" => "EUR",
            "FJD" => "FJD",
            "FKP" => "FKP",
            "GBP" => "GBP",
            "GEL" => "GEL",
            "GHS" => "GHS",
            "GIP" => "GIP",
            "GMD" => "GMD",
            "GNF" => "GNF",
            "GQE" => "GQE",
            "GTQ" => "GTQ",
            "GYD" => "GYD",
            "HKD" => "HKD",
            "HNL" => "HNL",
            "HRK" => "HRK",
            "HTG" => "HTG",
            "HUF" => "HUF",
            "IDR" => "IDR",
            "ILS" => "ILS",
            "INR" => "INR",
            "IQD" => "IQD",
            "IRR" => "IRR",
            "ISK" => "ISK",
            "JMD" => "JMD",
            "JOD" => "JOD",
            "JPY" => "JPY",
            "KES" => "KES",
            "KGS" => "KGS",
            "KHR" => "KHR",
            "KMF" => "KMF",
            "KPW" => "KPW",
            "KRW" => "KRW",
            "KWD" => "KWD",
            "KYD" => "KYD",
            "KZT" => "KZT",
            "LAK" => "LAK",
            "LBP" => "LBP",
            "LKR" => "LKR",
            "LRD" => "LRD",
            "LSL" => "LSL",
            "LTL" => "LTL",
            "LVL" => "LVL",
            "LYD" => "LYD",
            "MAD" => "MAD",
            "MDL" => "MDL",
            "MGA" => "MGA",
            "MKD" => "MKD",
            "MMK" => "MMK",
            "MNT" => "MNT",
            "MOP" => "MOP",
            "MRO" => "MRO",
            "MUR" => "MUR",
            "MVR" => "MVR",
            "MWK" => "MWK",
            "MXN" => "MXN",
            "MYR" => "MYR",
            "MZM" => "MZM",
            "NAD" => "NAD",
            "NGN" => "NGN",
            "NIO" => "NIO",
            "NOK" => "NOK",
            "NPR" => "NPR",
            "NZD" => "NZD",
            "OMR" => "OMR",
            "PAB" => "PAB",
            "PEN" => "PEN",
            "PGK" => "PGK",
            "PHP" => "PHP",
            "PKR" => "PKR",
            "PLN" => "PLN",
            "PYG" => "PYG",
            "QAR" => "QAR",
            "RON" => "RON",
            "RSD" => "RSD",
            "RUB" => "RUB",
            "SAR" => "SAR",
            "SBD" => "SBD",
            "SCR" => "SCR",
            "SDG" => "SDG",
            "SEK" => "SEK",
            "SGD" => "SGD",
            "SHP" => "SHP",
            "SLL" => "SLL",
            "SOS" => "SOS",
            "SRD" => "SRD",
            "SYP" => "SYP",
            "SZL" => "SZL",
            "THB" => "THB",
            "TJS" => "TJS",
            "TMT" => "TMT",
            "TND" => "TND",
            "TRY" => "TRY",
            "TTD" => "TTD",
            "TWD" => "TWD",
            "TZS" => "TZS",
            "UAH" => "UAH",
            "UGX" => "UGX",
            "USD" => "USD",
            "UYU" => "UYU",
            "UZS" => "UZS",
            "VEB" => "VEB",
            "VND" => "VND",
            "VUV" => "VUV",
            "WST" => "WST",
            "XAF" => "XAF",
            "XCD" => "XCD",
            "XDR" => "XDR",
            "XOF" => "XOF",
            "XPF" => "XPF",
            "YER" => "YER",
            "ZAR" => "ZAR",
            "ZMK" => "ZMK",
            "ZWR" => "ZWR"
        ];
    }

    /**
     * Get an array containing the ShoppingCart own page types
     * Useful to determine if the current page is own or another one
     *
     * @return array
     */
    public function getOwnPageTypes()
    {
        return [
            'shoppingcart_categories',
            'shoppingcart_products',
            'shoppingcart_product',
            'shoppingcart_checkout',
            'shoppingcart_order',
            //Add deprecated page types
            'shoppingcart',
            'shoppingcart_category',
            'shoppingcart_detail',
        ];
    }

    /**
     * Returns the symbol of the passed currency code
     *
     * @param $currencyCode
     *
     * @return mixed
     */
    public static function getSymbolOfCurrencyCode($currencyCode) {
        $currencyCode = strtoupper($currencyCode);

        $currencies = [
            "AED" => "\u062f.\u0625;",
            "AFN" => "Afs",
            "ALL" => "L",
            "AMD" => "AMD",
            "ANG" => "NA\u0192",
            "AOA" => "Kz",
            "ARS" => "$",
            "AUD" => "$",
            "AWG" => "\u0192",
            "AZN" => "AZN",
            "BAM" => "KM",
            "BBD" => "Bds$",
            "BDT" => "\u09f3",
            "BGN" => "BGN",
            "BHD" => ".\u062f.\u0628",
            "BIF" => "FBu",
            "BMD" => "BD$",
            "BOB" => "Bs.",
            "BRL" => "R$",
            "BSD" => "B$",
            "BTN" => "Nu.",
            "BWP" => "P",
            "BYR" => "Br",
            "BZD" => "BZ$",
            "CAD" => "$",
            "CDF" => "F",
            "CHF" => "Fr.",
            "CLP" => "$",
            "CNY" => "\u00a5",
            "COP" => "Col$",
            "CRC" => "\u20a1",
            "CUC" => "$",
            "CVE" => "Esc",
            "CZK" => "K\u010d",
            "DJF" => "Fdj",
            "DKK" => "DKK",
            "DOP" => "RD$",
            "DZD" => "\u062f.\u062c",
            "EEK" => "EEK",
            "EGP" => "\u00a3",
            "ERN" => "Nfa",
            "ETB" => "Br",
            "EUR" => "\u20ac",
            "FJD" => "FJ$",
            "FKP" => "\u00a3",
            "GBP" => "\u00a3",
            "GEL" => "GEL",
            "GHS" => "GH\u20b5",
            "GIP" => "\u00a3",
            "GMD" => "D",
            "GNF" => "FG",
            "GQE" => "CFA",
            "GTQ" => "Q",
            "GYD" => "GY$",
            "HKD" => "HK$",
            "HNL" => "L",
            "HRK" => "kn",
            "HTG" => "G",
            "HUF" => "Ft",
            "IDR" => "Rp",
            "ILS" => "\u20aa",
            "INR" => "\u2089",
            "IQD" => "\u062f.\u0639",
            "IRR" => "IRR",
            "ISK" => "ISK",
            "JMD" => "J$",
            "JOD" => "JOD",
            "JPY" => "\u00a5",
            "KES" => "KSh",
            "KGS" => "\u0441\u043e\u043c",
            "KHR" => "\u17db",
            "KMF" => "KMF",
            "KPW" => "W",
            "KRW" => "W",
            "KWD" => "KWD",
            "KYD" => "KY$",
            "KZT" => "T",
            "LAK" => "KN",
            "LBP" => "\u00a3",
            "LKR" => "Rs",
            "LRD" => "L$",
            "LSL" => "M",
            "LTL" => "Lt",
            "LVL" => "Ls",
            "LYD" => "LD",
            "MAD" => "MAD",
            "MDL" => "MDL",
            "MGA" => "FMG",
            "MKD" => "MKD",
            "MMK" => "K",
            "MNT" => "\u20ae",
            "MOP" => "P",
            "MRO" => "UM",
            "MUR" => "Rs",
            "MVR" => "Rf",
            "MWK" => "MK",
            "MXN" => "$",
            "MYR" => "RM",
            "MZM" => "MTn",
            "NAD" => "N$",
            "NGN" => "\u20a6",
            "NIO" => "C$",
            "NOK" => "NOK",
            "NPR" => "NRs",
            "NZD" => "NZ$",
            "OMR" => "OMR",
            "PAB" => "B./",
            "PEN" => "S/.",
            "PGK" => "K",
            "PHP" => "\u20b1",
            "PKR" => "Rs.",
            "PLN" => "z\u0142",
            "PYG" => "\u20b2",
            "QAR" => "QR",
            "RON" => "L",
            "RSD" => "din.",
            "RUB" => "R",
            "SAR" => "SR",
            "SBD" => "SI$",
            "SCR" => "SR",
            "SDG" => "SDG",
            "SEK" => "SEK",
            "SGD" => "S$",
            "SHP" => "\u00a3",
            "SLL" => "Le",
            "SOS" => "Sh.",
            "SRD" => "$",
            "SYP" => "LS",
            "SZL" => "E",
            "THB" => "\u0e3f",
            "TJS" => "TJS",
            "TMT" => "m",
            "TND" => "DT",
            "TRY" => "TL",
            "TTD" => "TT$",
            "TWD" => "NT$",
            "TZS" => "TZS",
            "UAH" => "грн.",
            "UGX" => "USh",
            "USD" => "$",
            "UYU" => '$U',
            "UZS" => "UZS",
            "VEB" => "Bs",
            "VND" => "\u20ab",
            "VUV" => "VT",
            "WST" => "WS$",
            "XAF" => "CFA",
            "XCD" => "EC$",
            "XDR" => "SDR",
            "XOF" => "CFA",
            "XPF" => "F",
            "YER" => "YER",
            "ZAR" => "R",
            "ZMK" => "ZK",
            "ZWR" => "Z$"
        ];

        return json_decode('"' . $currencies[$currencyCode] . '"'); //Because JSON directly supports the \uxxxx syntax
    }

    /**
     * Get an array for the Countries settings, which includes the "All countries without specific rule" option
     *
     * @return array
     */
    public static function getShippingCountries()
    {
        return array_merge(['*' => 'All countries without specific rule'], self::getCountries());
    }

    /**
     * Get an array containing the strings used in the frontend (js) translations
     *
     * @return array
     */
    public function getTranslationStringsForFrontend()
    {
        return [
            'DETAILS',
            'PRICE',
            'INCLUDING_TAXES',
            'EXCLUDING_TAXES',
            'ADD_TO_CART',
            'DESCRIPTION',
            'NO_PRODUCTS_FOUND',
            'CHECKOUT_PAGE_TITLE',
            'CHECKOUT_STEP1_BILLING_DETAILS_TITLE',
            'CHECKOUT_HEADLINE_YOUR_PERSONAL_DETAILS',
            'CHECKOUT_FIRST_NAME',
            'CHECKOUT_LAST_NAME',
            'CHECKOUT_EMAIL',
            'CHECKOUT_PHONE',
            'CHECKOUT_HEADLINE_YOUR_ADDRESS',
            'CHECKOUT_ADDRESS_1',
            'CHECKOUT_ADDRESS_2',
            'CHECKOUT_CITY',
            'CHECKOUT_ZIP',
            'CHECKOUT_COUNTRY',
            'CHECKOUT_STATE',
            'CHECKOUT_PROVINCE',
            'CHECKOUT_BUTTON_GO_TO_STEP_2',
            'CHECKOUT_STEP2_SHIPPING_PAYMENT_DETAILS_TITLE',
            'CHECKOUT_CHOOSE_SHIPPING_METHOD',
            'CHECKOUT_CHOOSE_SHIPPING_METHOD_DESC',
            'CHECKOUT_CHOOSE_PAYMENT_METHOD',
            'CHECKOUT_CHOOSE_PAYMENT_METHOD_QUESTION',
            'CHECKOUT_PAYMENT_SECURE_NOTE',
            'CHECKOUT_BUTTON_BACK',
            'CHECKOUT_BUTTON_PAY',
            'PRICE_DO_NOT_INCLUDE_TAXES',
            'ORDER_SUCCESSFUL_PAGE_TITLE',
            'ITEMS_PURCHASED',
            'ORDER_SUCCESSFUL_CONFIRMATION_TEXT',
            'ORDER_PAGE_WRONG_TOKEN_MESSAGE',
            'LOADING_WORD_BEFORE_ORDER_CONFIRMATION_PAGE',
            'DOWNLOAD',
            'SHOPPING_CART',
            'YOU_ARE_PURCHASING_THESE_ITEMS',
            'ITEM',
            'QUANTITY',
            'TOTAL',
            'REMOVE',
            'UPDATE_QUANTITIES',
            'CHECKOUT',
            'INCLUDING_SHIPPING',
            'ORDER_NOT_PAID_YET',
            'ORDER_CANCELLED',
            'YOU_CANCELLED_THE_ORDER',
            'VALUE_NOT_ACCEPTABLE',
            'QUANTITY_EXCEEDS_MAX_ALLOWED_VALUE',
            'CHECKOUT_PAYMENT_METHOD',
            'CHECKOUT_SHIPPING_METHOD',
            'THANK_YOU',
            'OFFLINE_ORDER_TEXT',
            'CHOOSE_AN_OPTION',
            'EDIT_CART',
            'QUANTITY_SHORT',
            'NO_ITEMS_IN_CART',
            'PRODUCT_ADDED_TO_CART',
            'PRODUCTS_BOUGHT',
            'SEE_THE_ORDER_DETAILS',
            'MESSAGE_FROM_THE_CLIENT',
            'TERMS_AND_CONDITIONS',
            'SORRY_THE_EMAIL_IS_NOT_VALID',
            'SORRY_THE_EMAIL_IS_NOT_VALID_DID_YOU_MEAN',
            'SORRY_CANNOT_SHIP_TO_YOUR_COUNTRY',
            'PLEASE_FILL_PAYMENT_INFORMATION_TEXT_AREA',
            'PLEASE_FILL_ALL_THE_REQUIRED_FIELDS',
            'READ_MORE',
            'MINIMUM_TO_PLACE_AN_ORDER',
            'OUT_OF_STOCK',
            'PAYPAL',
            'CREDITCARD',
            'ITEMS_LEFT',
            'SUBCATEGORIES_HEADING',
            'SHIPPING',
            'TAXES',
            'SUBTOTAL',
            'CONTINUE_SHOPPING',
            'DOWNLOAD_EXPIRED',
            'TOTAL_PAID',
            'ORDER_ID',
            'ORDER_DATE',
            'NO_ORDERS_FOUND',
        ];
    }

}
